function [ber] = Estima_BER(bits_tx,bits_rx,BpS,Nc,N_FFT,CP)

disp('Inicio Funcion Estima_BER-------------------------------------')	

% Estima_BER: Estimador de BEr metodo Montecarlo

%Secuencia de bits de datos generados
bits_tx=bits_tx(:);
%Secuencia de bits de datos detectados
bits_rx=bits_rx(:);

% Clculo de la secuencia de bits efectiva transmitida. BitRateEfectivo=BitRate/(1+CP)
NTS_OFDM=floor(length(bits_tx)/(BpS*ceil(N_FFT*(1+CP)))); %N total de simbolos OFDM transmitidos
NTS_INFO=NTS_OFDM*Nc; %N total de simbolos de datos M-QAM transmmitidos
NTB_INFO=NTS_INFO*BpS %N total de bits de datos transmitidos

% N de errores sobre secuencias reales de bits transmitidas
n_er = sum (abs(bits_tx(1:NTB_INFO)-bits_rx(1:NTB_INFO)))
% Tasa de error estimada
ber = n_er/NTB_INFO

disp('Fin Funcion Estima_BER-------------------------------------')	