# Get Numpy library
from numpy import *;

#Procedure for Rx_El-OFDM_BER module data synchronization

def Resynchronize( CxIQ, IQ, UserParams, UserParamsVolatile ):
    CyclicPrefix = UserParams[0];
    NCarrier = UserParams[1];
    DMTflag=UserParams[2];
    L=size(CxIQ);
    N=round(L/2*(1-CyclicPrefix));

    # Preliminary gain recovery
    Factor = sqrt( sum( IQ[1:N] * IQ[1:N].conjugate() ) / sum( CxIQ[1:N] * CxIQ[1:N].conjugate() ) );
    #Mean phase rotation angle
    CxIQ = CxIQ * Factor;
    # For DMT coding discard invalid symbols by replacing them with
    #ideal values with proper phase
    if DMTflag == 1:
        #calculate mean phase shift discarding invalid symbols
        mean=complex(0,0);
        for i in range(0,L):
            if i%(NCarrier/2) <> 0:
                if IQ[i] <> 0:
                    mean=mean+CxIQ[i]/IQ[i];
        mPhase=angle(mean);
        #replace symbols
        for ind in range(0,L,(NCarrier/2)):
            CxIQ[ind]=IQ[ind]*exp(1j*mPhase);
    return CxIQ;
