function [H_mod H_fase]= Decoder_EstimaCanal_OFDM(bits_tx,y_real,y_imag,BitRate, SampleRate,TimeWindow,BpS,Nc,N_FFT,CP,Coder)

disp('Inicio Funcion Decoder_EstimaCanal_OFDM-------------------------------------')	

%% Seal Recibida

%Desplazamientyo circular que compensa retardo del modo ms lento
T1 = 1.4676e-6;  %Offset = 0
%T1 = 1.465e-6;  %Offset = 3e-6
%T1 = 1.466e-6;  %Offset = 3e-6

N1 = floor((T1/TimeWindow-floor(T1/TimeWindow))*TimeWindow*SampleRate);


signal_OFDM_rx = complex(y_real,y_imag);
signal_OFDM_rx = signal_OFDM_rx(:);
signal_OFDM_rx = [signal_OFDM_rx(N1+1:end); signal_OFDM_rx(1:N1)];
signal_OFDM_rx = signal_OFDM_rx(1:floor(SampleRate/(BitRate/BpS)):end);

% Clculo de la secuencia de bits efectiva transmitida. BitRateEfectivo=BitRate/(1+CP)
NTS_OFDM=floor(length(signal_OFDM_rx )/(ceil(N_FFT*(1+CP)))); %N total de simbolos OFDM transmitidos
NTS_INFO=Nc*NTS_OFDM; %N total de simbolos de datos M-QAM transmmitidos
NTB_INFO=NTS_INFO*BpS; %N total de bits de datos transmitidos
NTS_ZP=(N_FFT-Nc)*NTS_OFDM; %N total de smbolos M-QAM equivalentes a portadoras de guarda
NTS_CP=NTS_OFDM*ceil(N_FFT*CP); %N total de smbolos M-QAM equivalentes a intervalo de guarda
NTS_casados=NTS_INFO+NTS_ZP+NTS_ZP; %N total de simbolos M-QAM transmitidos

% Extraccin de secuencia de ceros que compensan perdida de Bit Rate  efectivo
signal_OFDM_rx = signal_OFDM_rx(1:NTS_OFDM*ceil(N_FFT*(1+CP))); 
signal_OFDM_rx = signal_OFDM_rx(:);

%% Seal transmitida

x = bits_tx(1:NTB_INFO);%Vector que contiene slo la secuencia de bits transmitida
x = x(:);

% Secuencia de smbolos M-QAM mapeados a partir de bits de datos
hm_trx=modem.qammod('M',2^BpS,'SymbolOrder','Gray','InputType','bit');
simb_QAM_tx = modulate(hm_trx,reshape(x,NTS_INFO,BpS));
simb_QAM_tx = reshape(simb_QAM_tx,Nc,NTS_OFDM);

% Insercion de bandas de guarda 
if(mod(N_FFT,2)== mod(Nc,2))
        simb_OFDM_tx =[simb_QAM_tx(1:Nc/2,:);zeros(N_FFT-Nc,NTS_OFDM);simb_QAM_tx((Nc/2)+1:Nc,:)]; 
else
    	disp('N_FFT y Nc deben ser pares o impares')
end

%% OFDM DECODER: Estimacion de canal
switch Coder
    
    case 1
        disp('EL modo de codificacin CYCLIC PREFIX')
        signal_OFDM_rx  = reshape(signal_OFDM_rx ,ceil(N_FFT*(1+CP)),NTS_OFDM);
        % Extraccin de  Cyclic Prefix
        signal_OFDM_rx  = signal_OFDM_rx ((ceil(N_FFT*CP)+1):size(signal_OFDM_rx ,1),:);
        % Decodificacion FFT
        simb_OFDM_rx  = fft(signal_OFDM_rx ,N_FFT)/sqrt(N_FFT);
        %%ESTIMACION DE CANAL
        H_est = simb_OFDM_rx./simb_OFDM_tx;

        
    case 2
        disp('EL modo de codificacin ZERO PADING')
        signal_OFDM_rx = reshape(signal_OFDM_rx,ceil(N_FFT*(1+CP)),NTS_OFDM);%
        %Ver [Muque02]
        x_p = fft(signal_OFDM_rx,ceil(N_FFT*(1+CP)))/sqrt(ceil(N_FFT*(1+CP))); %The FFT is performed
        %F_p es la DFT matrix de tamao [PxP]
        F_p = dftmtx(ceil(N_FFT*(1+CP)))/sqrt(ceil(N_FFT*(1+CP)));
        %F_m es la DFT matrix de tamao [N_FFTxN_FFT]
        F_m = dftmtx(N_FFT)/sqrt(N_FFT);
        F_zp = [F_m, zeros(N_FFT,ceil(N_FFT*CP))]';
        V = F_p*F_zp;
        v_p(1:ceil(N_FFT*(1+CP)),:) = V*simb_QAM_tx(1:N_FFT,:);
        %%ESTIMACION DE CANAL
        H_est = x_p./v_p;
        
        
    otherwise 
        disp('EL modo de codificacin OFDM no es correcto')
end


%% Promediado de la estima
H_est = mean(H_est,2);

H_mod = abs(H_est);
H_fase = unwrap(angle(H_est));




disp('Fin Funcion Decoder_EstimaCanal_OFDM-------------------------------------')	

